

#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <ArduinoJson.h>



#define m11 16               //D0
#define m12 5                //D1
#define m21 4                //D2
#define m22 0                //D3

DynamicJsonBuffer jsonBuffer;

const char *ssid      = "ssid";
const char *password  = "password";

int buttonValue0 = 0;        
int buttonValue1 = 0;        
int buttonValue2 = 0;        
int buttonValue3 = 0;        
String button_values;

ESP8266WebServer server(80);

void handleSentVar() {

  if (server.hasArg("button_reading"))
  {
    button_values = server.arg("button_reading");
    Serial.println(button_values);
  }
  JsonObject& root = jsonBuffer.parseObject(button_values);
//  if (!root.success()) {
//    Serial.println("parseObject() failed");
//    return;
//  }
//  if (root.success())
//  {
    buttonValue0          = root["button0_reading"].as<int>();
    buttonValue1          = root["button1_reading"].as<int>();
    buttonValue2          = root["button2_reading"].as<int>();
    buttonValue3          = root["button3_reading"].as<int>();

//  }

  Serial.println(buttonValue0);
  Serial.println(buttonValue1);
  Serial.println(buttonValue2);
  Serial.println(buttonValue3);

  toggle_leds();

  server.send(200, "text/html", "Data received");
}


void setup() {
  Serial.begin(9600);
  WiFi.softAP(ssid, password);
  IPAddress myIP = WiFi.softAPIP();

  pinMode(m11, OUTPUT);
  pinMode(m12, OUTPUT);
  pinMode(m21, OUTPUT);
  pinMode(m22, OUTPUT);
  
  //toggle_leds();                 //turn off all leds as all the button values are zero
  
  server.on("/data/", HTTP_GET, handleSentVar); // when the server receives a request with /data/ in the string then run the handleSentVar function
  server.begin();
}

void loop() {
  server.handleClient();
}

void toggle_leds()
{
  if (buttonValue0 == 0)  digitalWrite(m11, LOW);
  if (buttonValue1 == 0)  digitalWrite(m12, LOW);
  if (buttonValue2 == 0)  digitalWrite(m21, LOW);
  if (buttonValue3 == 0)  digitalWrite(m22, LOW);

  if (buttonValue0 == 1)  digitalWrite(m11, HIGH);
  if (buttonValue1 == 1)  digitalWrite(m12, HIGH);
  if (buttonValue2 == 1)  digitalWrite(m21, HIGH);
  if (buttonValue3 == 1)  digitalWrite(m22, HIGH);
}
